<?php
/*
 *******************************************
 plugin JUpload for Coppermine Photo Gallery
 *******************************************

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 ********************************************
 $Source: $
 $Revision: ?
 $Author: etienne_sf $
 $Date: $
 ********************************************
 *
 * Allows easy upload to the gallery, through a java applet. 
 * 
 * Up to date version of this script can be retrieved with the full JUpload package, here:
 * 
 * http://etienne.lesgauthier.fr/wiki
 * 
 * Directly here:
 * http://etienne.lesgauthier.fr/wiki/doku.php?id=jupload_coppermine_download_gb
 * 
 * Support is available on this forum:
 * http://coppermine-gallery.net/forum/index.php?topic=43432
 * 
 * The applet is published on sourceforge:
 * http://jupload.sourceforge.net
 * 
 */


if (!defined('IN_COPPERMINE')) { die('Not in Coppermine...');}
if (!defined('JUPLOAD_PHP')) { die('Not in Jupload...');}


/**
 * Taken from the get_subcat_data, from Coppermine core.
 *  
 * Modifications for JUpload:
 * - The function now returns a value, indicating the total number of albums contained in sub-categories
 * - The $CAT_LIST global variable now contains also:
 *    * 'nb_albums_in_subcategories', wich contains the total number of albums in which the user may upload
 *         in all subcategories if the current category.
 *    * 'nb_albums', which contains the number of albums in which the user may upload in the current categories. 
 */
function j_get_subcat_data($parent, $ident = '')
{
    global $CONFIG, $CAT_LIST, $albumsCountPerCategory;
    $return = 0;
    
	if ($CONFIG['categories_alpha_sort'] == 1) {
		$sort_query = 'name';
	} else {
		$sort_query = 'pos';
	}

    $sql =  " SELECT cid, name, description " . 
			" FROM {$CONFIG['TABLE_CATEGORIES']} " . 
			" WHERE parent = '$parent' " . 
			" ORDER BY $sort_query";
    $result = cpg_db_query($sql);

    if (($cat_count = mysql_num_rows($result)) > 0) {
        $rowset = cpg_db_fetch_rowset($result);
        $pos = 0;
        $prev_cid = 0;  //Just to prevent a warning in my IDE
        $last_index = 0;//Just to prevent a warning in my IDE
        foreach ($rowset as $subcat) {
            if ($pos > 0) {
                $CAT_LIST[] = array(
					'cid' => $subcat['cid'],
                    'parent' => $parent,
                    'pos' => $pos++,
                    'prev' => $prev_cid,
                    'cat_count' => $cat_count,
                    'name' => $ident . $subcat['name'],
                    'nb_albums' => $albumsCountPerCategory[$subcat['cid']],
                    'nb_albums_in_subcategories' => 0
                    );
                $CAT_LIST[$last_index]['next'] = $subcat['cid'];
            } else {
                $CAT_LIST[] = array(
					'cid' => $subcat['cid'],
                    'parent' => $parent,
                    'pos' => $pos++,
                    'cat_count' => $cat_count,
                    'name' => $ident . $subcat['name'],
                    'nb_albums' => $albumsCountPerCategory[$subcat['cid']],
                    'nb_albums_in_subcategories' => 0
                    );
            }
            $prev_cid = $subcat['cid'];
            $last_index = count($CAT_LIST) -1;
            $CAT_LIST[$last_index]['nb_albums_in_subcategories'] =
            	j_get_subcat_data($subcat['cid'], $ident . '&nbsp;&nbsp;&nbsp;');
            $return += $CAT_LIST[$last_index]['nb_albums'] + $CAT_LIST[$last_index]['nb_albums_in_subcategories']; 
        }//foreach
    }//if
    
    return $return;
}//j_get_subcat_data


/**
 * The following function is taken from the cat_list_box function, and adpated to Jupload.
 * The main difference (out of removing of code that is useless for JUpload) is the fact the value is
 * the category id. 
 */
function j_cat_list_box()
{
    global $CAT_LIST, $USER_DATA, $lang_albmgr_php, $lang_groupmgr_php, $category;
    global $lang_list_users, $albumsCountPerCategory;

	//Response to onChange: now in Ajax.    
	//First possibility: submit the form. Works Ok. To be removed 
	//$onChange="form_category.submit();";
	//Second possibility: loads the album list for this category in an ajax call.
	//To be validated in all language configurations.
	$onChange="ajax_load_a_category();";

//eecho("En user_mode, la 1�re cat�gorie doit �tre la galerie de l'utilisateur");

	$selected = ($category == 0) ? ' selected': '';

	//If the user may not have its own galery, I don't display the 'personal galery' category.	
	if (!$USER_DATA['can_create_albums']) {
		$rootValue = '';
		$rootText  = $lang_albmgr_php['no_category'];
	} else {
		$rootValue = FIRST_USER_CAT + USER_ID;
    	$nbAlbumsTxt = sprintf(
    						$lang_list_users['n_albums'], 
    						isset($albumsCountPerCategory[FIRST_USER_CAT + USER_ID]) ? $albumsCountPerCategory[FIRST_USER_CAT + USER_ID] : 0
    					);
		$rootText  = "{$lang_groupmgr_php['personal_gallery']} ($nbAlbumsTxt)";
	}
	$lb = <<<EOT
        <select name="category" class="listbox" onchange="$onChange">
        	<option value="$rootValue" $selected>$rootText</option>
EOT;

	//Let's go through all existing categories, and display:
	// If the use is the admin:
	//   All categories.
	// Otherwise:
	//   Only categories that contains:
	//     - albums where the user may upload,
	//     - subcategories that contains albums where the user may upload.
    foreach($CAT_LIST as $cat) {
    	if (!GALLERY_ADMIN_MODE) {
    		if ($cat['nb_albums'] == 0 && $cat['nb_albums_in_subcategories'] == 0) {
    			//No albums in this category, nor in sub-categories, where the user may upload pictures
    			continue;
    		} 
    	}
    	$nbAlbumsTxt = sprintf(
    						$lang_list_users['n_albums'], 
    						isset($albumsCountPerCategory[$cat['cid']]) ? $albumsCountPerCategory[$cat['cid']] : 0
    					);
    	if ($cat['cid'] != 1) {
			$selected = ($category == $cat['cid']) ? ' selected': '';
	       	$lb .= <<<EOT
	    	<option value="${cat['cid']}" $selected>${cat['name']} ($nbAlbumsTxt)</option>

EOT;
    	}
    }

    $lb .= <<<EOT
        </select>

EOT;

    return $lb;
}


/*
The following function simply list the categories. It doesn't display there hierarchy.

function jupload_cat_list_box() {
	global $CONFIG, $lang_albmgr_php, $category; //$category contains the given category, that is: the currently selected one.
	
	$sql =  " SELECT cid, name, description " . 
			" FROM {$CONFIG['TABLE_CATEGORIES']} " . 
			" WHERE cid < " . FIRST_USER_CAT . 
			" ORDER BY " .  (  ($CONFIG['categories_alpha_sort'] == 1)  ? 'name' : 'pos');
	$result = cpg_db_query($sql);
	$selected = ($category == 0) ? ' selected': '';
	$lb = <<<EOT
		<select name="category" class="listbox" onChange="ajax_load_a_category();">
			<option value="0" $selected>${lang_albmgr_php['no_category']}</option>
EOT
;
	while ($row=mysql_fetch_array($result)) {
		$selected = ($category == $row['cid']) ? ' selected': '';
		$lb .= "			<option value='${row['cid']}' $selected>${row['name']}</option>";
	}//while

    $lb .= '		</select>';
    
    return $lb;
}
*/