<?php
/*
 *******************************************
 plugin JUpload for Coppermine Photo Gallery
 *******************************************

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 ********************************************
 $Source: $
 $Revision: ?
 $Author: etienne_sf $
 $Date: $
 ********************************************
 *
 * Allows easy upload to the gallery, through a java applet. 
 * 
 * Up to date version of this script can be retrieved with the full JUpload package, here:
 * 
 * http://etienne.lesgauthier.fr/wiki
 * 
 * Directly here:
 * http://etienne.lesgauthier.fr/wiki/doku.php?id=jupload_coppermine_download_gb
 * 
 * Support is available on this forum:
 * http://coppermine-gallery.net/forum/index.php?topic=43432
 * 
 * The applet is published on sourceforge:
 * http://jupload.sourceforge.net
 * 
 */


/*
 * Created on 30 janv. 07
 *
 * To change the template for this generated file go to
 * Window - Preferences - PHPeclipse - PHP - Code Templates
 */

if (!defined('IN_COPPERMINE')) { die('Not in Coppermine...');}
if (!defined('JUPLOAD_PHP')) { die('Not in Jupload...');}


if (!GALLERY_ADMIN_MODE) {
	$msg = str_replace('$1', 'login.php?referer=plugins/jupload/jupload.php', $lang_jupload_php['perm_denied']);

	cpg_die(ERROR, $msg, __FILE__, __LINE__);
}



//This page must not be cached by the navigator.
//Let's suppos we are in HTTP/1.1:
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);

/////////////////////////////////////////////////////////////////////////////////////////////////
//            CONFIGURATION STORAGE MIGRATION: config.inc.php -> Coppermine database
/////////////////////////////////////////////////////////////////////////////////////////////////
//This code is to be removed, when I can suppose that nobody still use 2.5.x or older version.
//Until JUpload v2.5.x, the configuration was stored in plugins/jupload/user/config/inc.php
//Since 2.6.0, the JUpload configuration is stored in the Coppermine database. The following
//lines check if this file exists. If yes, the configuration it contains is migrated toward the
//database. This will happen only once, as the file is then deleted.
$config_inc = "$juploadRootDirectory/user/config.inc.php";
if (file_exists($config_inc)) {
	//The file exists.
	//Let's migrate the config parameters to the config table
	migrateConfigFileToConfigTable();
}
/////////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////////
//            CONFIGURATION STORAGE MIGRATION: config.inc.php -> Coppermine database
/////////////////////////////////////////////////////////////////////////////////////////////////
//Since 3.0.0, there is a JUpload specific session management, that can be activated by using the
//sessionManagement configuration parameter.
//The following function creates this table, if it doesn't already exist.
createJUploadSessionTable();


//####################################################################################################
//#################################    FUNCTIONS    ##################################################
//####################################################################################################



///////////////////////////////////////////////////////////////////////
/////////////////   MANAGEMENT OF POST DATA        ////////////////////
///////////////////////////////////////////////////////////////////////

if ($action == 'store_config') {

	//No more save in the php config file: we store the JUpload configuration in the config table.
	//$htmlWriteConfigResult = writeJuploadConfigFile();
	saveJuploadConfigParamInCoppermineDatabase($_POST);
	
	//Saved: we say this good news to the user !  ;-)
    pageheader('JUpload configuration');
    msg_box($lang_admin_php['info'], $lang_admin_php['upd_success'], $lang_continue, $JUPLOAD_VAR['SELF'] . "&action=config");
    pagefooter();
    
    //Let's stop here
    exit;
}

///////////////////////////////////////////////////////////////////////
///   RELOAD DATA, TO DISTINGUISH REAL VALUES FROM DEFAULT VALUES    //
///////////////////////////////////////////////////////////////////////
//We clear the calculated config
unset($JUPLOAD_CONFIG);
//Recalculate the JUPLOAD_CONFIG array, without the default values.
initJuploadConfig(false);

/*
 * Next code is Ok when managing the configuration into a php file.

//Then, we load exactly the content of the config file (or nothing, if it doesn't exist)
$config_inc = $juploadRootDirectory . 'user/config.inc.php';
if (file_exists($config_inc)) { 
	require($config_inc);
}
*/


///////////////////////////////////////////////////////////////////////
///////////////   GENERATION OF THE HTML CONTENT    ///////////////////
///////////////////////////////////////////////////////////////////////

pageheader('JUpload configuration');

echo ('<form method="post" name="form_album" enctype="multipart/form-data" action="index.php?file=jupload/jupload&action=store_config">');
	starttable('100%', 'JUpload configuration', 2);
		if (isset($htmlPostResult)) {
			form_statement ("<FONT color=red>An error occured: $htmlPostResult</FONT>");
		}
		if (isset($htmlWriteConfigResult) && $htmlWriteConfigResult != '') {
			form_statement ("<FONT color=red>An error occured: $htmlWriteConfigResult</FONT>");
		}
		
		//First: the table of content, to access directly to each parameters
		form_statement (getTableOfContent());
		
		//Let's display some help.		
		form_statement ($hint);		
		
		//Then, the list of parameters, with: name, description, 
		foreach ($JUploadParamList as $paramName=>$param) {			
			form_statement ("<B><a name='$paramName'>$paramName</a></B>");		
			form_statement ($param['desc']);		
			form_statement ("Default value is '${param['default']}'");		
			text_box_input(	$paramName, 
							$paramName, 
							255, 
							1, 
							isset($JUPLOAD_CONFIG[$paramName]) ? $JUPLOAD_CONFIG[$paramName] : ''
							); 
			form_statement ('<BR>');		
		}
	
		$submit_buttons = array (
			    array('value' => 'Store configuration'),
		    );
		submit_button($submit_buttons);
	endtable();
echo ("</form>");
pagefooter();
//ob_end_flush();
